Bug 2283281 - Review Request: python-pyshacl - Python validator for SHACL
Summary: Review Request: python-pyshacl - Python validator for SHACL
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: wojnilowicz
QA Contact: Fedora Extras Quality Assurance
URL: https://github.com/RDFLib/pySHACL
Whiteboard:
Depends On:
Blocks: scancode-toolkit
TreeView+ depends on / blocked
 
Reported: 2024-05-26 04:53 UTC by Robert-André Mauchin 🐧
Modified: 2024-06-28 01:58 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2024-06-28 01:58:04 UTC
Type: ---
Embargoed:
lukasz.wojnilowicz: fedora-review+


Attachments (Terms of Use)
The .spec file difference from Copr build 7610467 to 7613958 (2.51 KB, patch)
2024-06-14 03:41 UTC, Fedora Review Service
no flags Details | Diff
The .spec file difference from Copr build 7613958 to 7617842 (670 bytes, patch)
2024-06-16 00:27 UTC, Fedora Review Service
no flags Details | Diff

Description Robert-André Mauchin 🐧 2024-05-26 04:53:01 UTC
Spec URL: https://eclipseo.fedorapeople.org/for-review/python-pyshacl.spec
SRPM URL: https://eclipseo.fedorapeople.org/for-review/python-pyshacl-0.26.0-1.fc40.src.rpm

Description:
This is a pure Python module which allows for the validation of RDF graphs against Shapes Constraint Language (SHACL) graphs. This module uses the rdflib Python library for working with RDF and is dependent on the OWL-RL Python module for OWL2 RL Profile based expansion of data graphs.

Fedora Account System Username: eclipseo

Comment 1 Fedora Review Service 2024-05-26 04:55:12 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/7492818
(failed)

Build log:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2283281-python-pyshacl/fedora-rawhide-x86_64/07492818-python-pyshacl/builder-live.log.gz

Please make sure the package builds successfully at least for Fedora Rawhide.

- If the build failed for unrelated reasons (e.g. temporary network
  unavailability), please ignore it.
- If the build failed because of missing BuildRequires, please make sure they
  are listed in the "Depends On" field


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 3 wojnilowicz 2024-06-02 12:35:03 UTC
I'm not a golang user, so I couldn't help with your many golang package reviews, but this one I can take :)

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
1) Downloading "Source: https://github.com/RDFLib/pySHACL/archive/v0.26.0/pyshacl-0.26.0.tar.gz"
gives me
line 42: cd: pyshacl-0.26.0: No such file or directory
when "rpmbuild --bb python-pyshacl.spec"
because the directory is "pySHACL-0.26.0" and not "pyshacl-0.26.0"
In your SRPM file it's fine though. Did you download it in any special way?

Besides this is what fedora-review gave
- Sources used to build the package match the upstream source, as provided
  in the spec URL.
  Note: Upstream MD5sum check error, diff is in /var/lib/copr-
  rpmbuild/results/python-pyshacl/diff.txt
  See: https://docs.fedoraproject.org/en-US/packaging-guidelines/SourceURL/


2) Could you add man pages for the following files:
python3-pyshacl.noarch: W: no-manual-page-for-binary pyshacl
python3-pyshacl.noarch: W: no-manual-page-for-binary pyshacl_server
python3-pyshacl.noarch: W: no-manual-page-for-binary pyshacl_validate
with
help2man --no-discard-stderr %{buildroot}%{_bindir}/pyshacl -o %{buildroot}%{_mandir}/man1/pyshacl.1
?
There is quite a lot written there.

3) Could you deduplicate the following files
thon3-pyshacl.noarch: W: files-duplicate /usr/bin/pyshacl_validate /usr/bin/pyshacl
python3-pyshacl.noarch: W: files-duplicate /usr/lib/python3.12/site-packages/pyshacl/constraints/sparql/__init__.py /usr/lib/python3.12/site-packages/pyshacl/constraints/core/__init__.py
with the %fdupes macro?

4) Could you fix that according to https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/#_interpreter_invocation?
python3-pyshacl.noarch: E: non-executable-script /usr/lib/python3.12/site-packages/pyshacl/cli.py 644 /usr/bin/env python3

5) Could you remove pyshacl-cli.spec? It seem to be used for exe only.

6) The spec file in your SRPM has the following typo
"< # Disable netweork dependent tests"
and thus differs from the spec file you attached here. This fails the checklist. Could you correct this?

7) It builds only on rawhide due to dependencies, but I guess that's fine.


===== MUST items =====

Generic:
[!]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
     Note: Using prebuilt packages
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "*No copyright* Apache License 2.0".
     410 files have unknown license. Detailed output of licensecheck in
     /var/lib/copr-rpmbuild/results/python-pyshacl/licensecheck.txt
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/bin, /usr/lib/python3.12, /usr,
     /usr/share/doc, /usr/share, /usr/lib/python3.12/site-packages,
     /usr/lib, /usr/share/licenses
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/bin, /usr/lib/python3.12,
     /usr, /usr/share/doc, /usr/lib, /usr/share, /usr/share/licenses,
     /usr/lib/python3.12/site-packages
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 96442 bytes in 5 files.
[!]: Package complies to the Packaging Guidelines
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: The License field must be a valid SPDX expression.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[-]: Binary eggs must be removed in %prep
     Note: Cannot find any build in BUILD directory (--prebuilt option?)
[-]: Python eggs must not download any dependencies during the build
     process.
[-]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Bad spec filename: /var/lib/copr-rpmbuild/results/python-
     pyshacl/srpm-unpacked/python-pyshacl.spec
     See: (this test has no URL)
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.


Rpmlint
-------
Checking: python3-pyshacl-0.26.0-1.fc41.noarch.rpm
          python-pyshacl-0.26.0-1.fc41.src.rpm
============================ rpmlint session starts ============================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmpkii_60wy')]
checks: 32, packages: 2

python-pyshacl.src: E: spelling-error ('validator', 'Summary(en_US) validator -> lavatorial')
python-pyshacl.src: E: spelling-error ('rdflib', '%description -l en_US rdflib -> rifling')
python3-pyshacl.noarch: E: spelling-error ('validator', 'Summary(en_US) validator -> lavatorial')
python3-pyshacl.noarch: E: spelling-error ('rdflib', '%description -l en_US rdflib -> rifling')
python3-pyshacl.noarch: E: non-executable-script /usr/lib/python3.12/site-packages/pyshacl/cli.py 644 /usr/bin/env python3
python3-pyshacl.noarch: W: no-manual-page-for-binary pyshacl
python3-pyshacl.noarch: W: no-manual-page-for-binary pyshacl_server
python3-pyshacl.noarch: W: no-manual-page-for-binary pyshacl_validate
python3-pyshacl.noarch: W: files-duplicate /usr/bin/pyshacl_validate /usr/bin/pyshacl
python3-pyshacl.noarch: W: files-duplicate /usr/lib/python3.12/site-packages/pyshacl/constraints/sparql/__init__.py /usr/lib/python3.12/site-packages/pyshacl/constraints/core/__init__.py
 2 packages and 0 specfiles checked; 5 errors, 5 warnings, 12 filtered, 5 badness; has taken 0.5 s 




Rpmlint (installed packages)
----------------------------
(none): E: there is no installed rpm "python3-pyshacl".
There are no files to process nor additional arguments.
Nothing to do, aborting.
============================ rpmlint session starts ============================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 32, packages: 1

 0 packages and 0 specfiles checked; 0 errors, 0 warnings, 0 filtered, 0 badness; has taken 0.0 s 



Source checksums
----------------
https://github.com/RDFLib/pySHACL/archive/v0.26.0/pyshacl-0.26.0.tar.gz :
  CHECKSUM(SHA256) this package     : 48d44f317cd9aad8e3fdb5df8aa5706fa92dc6b2746419698035e84a320fb89d
  CHECKSUM(SHA256) upstream package : a5a2abb94ac2b429ef3a92b42192c48bfdf66462355696023153e97d5a10136d
diff -r also reports differences


Requires
--------
python3-pyshacl (rpmlib, GLIBC filtered):
    (python3.12dist(html5lib) < 2~~ with python3.12dist(html5lib) >= 1.1)
    (python3.12dist(owlrl) < 7~~ with python3.12dist(owlrl) >= 6.0.2)
    (python3.12dist(rdflib) < 8~~ with python3.12dist(rdflib) >= 6.3.2)
    /usr/bin/python3
    python(abi)
    python3.12dist(packaging)
    python3.12dist(prettytable)



Provides
--------
python3-pyshacl:
    python-pyshacl
    python3-pyshacl
    python3.12-pyshacl
    python3.12dist(pyshacl)
    python3dist(pyshacl)



Generated by fedora-review 0.10.0 (e79b66b) last change: 2023-07-24
Command line :/bin/fedora-review --no-colors --prebuilt --rpm-spec --name python-pyshacl --mock-config /var/lib/copr-rpmbuild/results/configs/child.cfg
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Shell-api, Generic
Disabled plugins: Haskell, C/C++, Java, PHP, fonts, Perl, Ocaml, SugarActivity, R
Disabled flags: EXARCH, EPEL6, EPEL7, DISTTAG, BATCH

Comment 4 Robert-André Mauchin 🐧 2024-06-12 18:52:18 UTC
Spec URL: https://eclipseo.fedorapeople.org/for-review/python-pyshacl.spec
SRPM URL: https://eclipseo.fedorapeople.org/for-review/python-pyshacl-0.26.0-1.fc40.src.rpm

Thank you for the review!

1) Weird, it seems I hadn't built it yet but this bug

2) Man page added. I had to remove pyshacl_server because it was not functionnal. It depends on -x http which needs extra deps which I am not willing to spend time on.

3) Done with fdupes

4) chmod +x the cli file

5) Done. Removed through the patch to the pyproject.toml.

6) Already fixed on my local file, apparently.

7) I will target F40 too, I relaxed the poetry and poetry-core dependencies. They bumped it for Black, but we do not depend on this for the build process.


Fedora-review on my COPR:

Rawhide: https://download.copr.fedorainfracloud.org/results/eclipseo/scancode-toolkit/fedora-rawhide-x86_64/07610451-python-pyshacl/fedora-review/review.txt
F40: https://download.copr.fedorainfracloud.org/results/eclipseo/scancode-toolkit/fedora-40-x86_64/07610451-python-pyshacl/fedora-review/review.txt

My builds:

https://copr.fedorainfracloud.org/coprs/eclipseo/scancode-toolkit/build/7610451/

Happy RPMLint:

Rpmlint
-------
Checking: python3-pyshacl-0.26.0-1.fc41.noarch.rpm
          python-pyshacl-0.26.0-1.fc41.src.rpm
============================ rpmlint session starts ============================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmpys5cklk6')]
checks: 32, packages: 2

python-pyshacl.src: E: spelling-error ('validator', 'Summary(en_US) validator -> lavatorial')
python-pyshacl.src: E: spelling-error ('rdflib', '%description -l en_US rdflib -> rifling')
python3-pyshacl.noarch: E: spelling-error ('validator', 'Summary(en_US) validator -> lavatorial')
python3-pyshacl.noarch: E: spelling-error ('rdflib', '%description -l en_US rdflib -> rifling')
python3-pyshacl.noarch: W: cross-directory-hard-link /usr/lib/python3.12/site-packages/pyshacl/constraints/sparql/__init__.py /usr/lib/python3.12/site-packages/pyshacl/constraints/core/__init__.py
 2 packages and 0 specfiles checked; 4 errors, 1 warnings, 12 filtered, 4 badness; has taken 0.5 s 




Rpmlint (installed packages)
----------------------------
(none): E: there is no installed rpm "python3-pyshacl".
There are no files to process nor additional arguments.
Nothing to do, aborting.
============================ rpmlint session starts ============================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 32, packages: 1

 0 packages and 0 specfiles checked; 0 errors, 0 warnings, 0 filtered, 0 badness; has taken 0.0 s

Comment 5 Fedora Review Service 2024-06-12 18:59:43 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/7610467
(succeeded)

Review template:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2283281-python-pyshacl/fedora-rawhide-x86_64/07610467-python-pyshacl/fedora-review/review.txt

Please take a look if any issues were found.


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 6 wojnilowicz 2024-06-13 17:37:35 UTC
Thanks. Everything seems OK, except this
"5) Done. Removed through the patch to the pyproject.toml."
pyshacl-cli.spec is still there and following comment
"# Also remove extra spec file for win32 cli, keep ths one."
doesn't do what it says. There is also a typo in "keep ths one." Did you mean "keep this one", like specifically python-pyshacl.spec? It's a bit difficult to understand.
I would remove either pyshacl-cli.spec or this comment and the hunk of it in the patch. After all I cannot find anywhere that I should review with respect to bloat files :)

You also have several lines commented out due to the extra dependencies for http and explained it only at one of the commented lines. Please take it as a suggestion only: I think it would look better with the use of:
1) %bcond http 0
2) %{?with_http:-x http}
3) %if %{with http} yourcode %endif
as can be seen at
https://rathann.fedorapeople.org/review/python-detect-secrets/python-detect-secrets.spec ("%bcond gibberish 0" specifically)
https://src.fedoraproject.org/rpms/workrave/blob/rawhide/f/workrave.spec ("%{?with_mate:ON}" specifically)

Comment 7 Robert-André Mauchin 🐧 2024-06-14 03:39:01 UTC
Spec URL: https://eclipseo.fedorapeople.org/for-review/python-pyshacl.spec
SRPM URL: https://eclipseo.fedorapeople.org/for-review/python-pyshacl-0.26.0-1.fc40.src.rpm


Yes good idea, I implemented the conditional build.

I split the patch in 2 to be cleared:
 - one patch to drop the pyshacl-cli.spec from install
 - one patch to relax the poetry dependencies, which will be dropped when F40 is EOL.

Thank you.

Comment 8 Fedora Review Service 2024-06-14 03:41:26 UTC
Created attachment 2037196 [details]
The .spec file difference from Copr build 7610467 to 7613958

Comment 9 Fedora Review Service 2024-06-14 03:41:28 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/7613958
(failed)

Build log:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2283281-python-pyshacl/fedora-rawhide-x86_64/07613958-python-pyshacl/builder-live.log.gz

Please make sure the package builds successfully at least for Fedora Rawhide.

- If the build failed for unrelated reasons (e.g. temporary network
  unavailability), please ignore it.
- If the build failed because of missing BuildRequires, please make sure they
  are listed in the "Depends On" field


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 10 wojnilowicz 2024-06-15 16:08:38 UTC
(In reply to Robert-André Mauchin 🐧 from comment #7)
> Spec URL: https://eclipseo.fedorapeople.org/for-review/python-pyshacl.spec
> SRPM URL:
> https://eclipseo.fedorapeople.org/for-review/python-pyshacl-0.26.0-1.fc40.
> src.rpm
> 
> 
> Yes good idea, I implemented the conditional build.

Thanks. That looks good. Shouldn't %{?with_http:x http} be %{?with_http:-x http} ?
The first one would expand to
"%pyproject_buildrequires -t x http"
but I believe you need
"%pyproject_buildrequires -t -x http"

> I split the patch in 2 to be cleared:
>  - one patch to drop the pyshacl-cli.spec from install
>  - one patch to relax the poetry dependencies, which will be dropped when
> F40 is EOL.

I'm not sure that helped. You don't see /usr/lib/python3.12/site-packages/pyshacl/pyshacl-cli.spec after installing your python3-pyshacl-0.26.0-1.fc40.noarch.rpm? I still do.

The package stopped building on rawhide. I don't see this as gating in the review template, but do you want to work it out before committing this package?

Comment 11 Robert-André Mauchin 🐧 2024-06-15 17:03:57 UTC
Ah it is in manifest too, I'll check after going out.

Comment 13 Fedora Review Service 2024-06-16 00:27:16 UTC
Created attachment 2037500 [details]
The .spec file difference from Copr build 7613958 to 7617842

Comment 14 Fedora Review Service 2024-06-16 00:27:19 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/7617842
(failed)

Build log:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2283281-python-pyshacl/fedora-rawhide-x86_64/07617842-python-pyshacl/builder-live.log.gz

Please make sure the package builds successfully at least for Fedora Rawhide.

- If the build failed for unrelated reasons (e.g. temporary network
  unavailability), please ignore it.
- If the build failed because of missing BuildRequires, please make sure they
  are listed in the "Depends On" field


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 15 wojnilowicz 2024-06-16 09:37:22 UTC
LGTM. The package is APPROVED.

Using the F40 review template as the package stopped building for Rawhide due to python3-owl_rl-6.0.2-12.fc40.noarch not being compatible with python 3.13 and no f41 package being available.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
     Note: Using prebuilt packages
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "*No copyright* Apache License 2.0".
     420 files have unknown license. Detailed output of licensecheck in
     /var/lib/copr-rpmbuild/results/python-pyshacl/licensecheck.txt
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/share, /usr/share/man,
     /usr/lib/python3.12, /usr/lib/python3.12/site-packages,
     /usr/share/man/man1, /usr/share/licenses, /usr/lib, /usr/share/doc,
     /usr/bin, /usr
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib, /usr/share,
     /usr/share/man, /usr/share/doc, /usr/lib/python3.12,
     /usr/lib/python3.12/site-packages, /usr/bin, /usr/share/man/man1,
     /usr, /usr/share/licenses
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 96442 bytes in 5 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: The License field must be a valid SPDX expression.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[-]: Binary eggs must be removed in %prep
     Note: Cannot find any build in BUILD directory (--prebuilt option?)
[-]: Python eggs must not download any dependencies during the build
     process.
[-]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.


Rpmlint
-------
Checking: python3-pyshacl-0.26.0-1.fc40.noarch.rpm
          python-pyshacl-0.26.0-1.fc40.src.rpm
============================ rpmlint session starts ============================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmpv4jvu19q')]
checks: 32, packages: 2

python-pyshacl.src: E: spelling-error ('validator', 'Summary(en_US) validator -> lavatorial')
python-pyshacl.src: E: spelling-error ('rdflib', '%description -l en_US rdflib -> rifling')
python3-pyshacl.noarch: E: spelling-error ('validator', 'Summary(en_US) validator -> lavatorial')
python3-pyshacl.noarch: E: spelling-error ('rdflib', '%description -l en_US rdflib -> rifling')
python3-pyshacl.noarch: W: cross-directory-hard-link /usr/lib/python3.12/site-packages/pyshacl/constraints/sparql/__init__.py /usr/lib/python3.12/site-packages/pyshacl/constraints/core/__init__.py
 2 packages and 0 specfiles checked; 4 errors, 1 warnings, 12 filtered, 4 badness; has taken 0.5 s 




Rpmlint (installed packages)
----------------------------
(none): E: there is no installed rpm "python3-pyshacl".
There are no files to process nor additional arguments.
Nothing to do, aborting.
============================ rpmlint session starts ============================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 32, packages: 1

 0 packages and 0 specfiles checked; 0 errors, 0 warnings, 0 filtered, 0 badness; has taken 0.0 s 



Source checksums
----------------
https://github.com/RDFLib/pySHACL/archive/v0.26.0/pyshacl-0.26.0.tar.gz :
  CHECKSUM(SHA256) this package     : a5a2abb94ac2b429ef3a92b42192c48bfdf66462355696023153e97d5a10136d
  CHECKSUM(SHA256) upstream package : a5a2abb94ac2b429ef3a92b42192c48bfdf66462355696023153e97d5a10136d


Requires
--------
python3-pyshacl (rpmlib, GLIBC filtered):
    (python3.12dist(html5lib) < 2~~ with python3.12dist(html5lib) >= 1.1)
    (python3.12dist(owlrl) < 7~~ with python3.12dist(owlrl) >= 6.0.2)
    (python3.12dist(rdflib) < 8~~ with python3.12dist(rdflib) >= 6.3.2)
    /usr/bin/python3
    python(abi)
    python3.12dist(packaging)
    python3.12dist(prettytable)



Provides
--------
python3-pyshacl:
    python-pyshacl
    python3-pyshacl
    python3.12-pyshacl
    python3.12dist(pyshacl)
    python3dist(pyshacl)



Generated by fedora-review 0.10.0 (e79b66b) last change: 2023-07-24
Command line :/bin/fedora-review --no-colors --prebuilt --rpm-spec --name python-pyshacl --mock-config /var/lib/copr-rpmbuild/results/configs/child.cfg
Buildroot used: fedora-40-x86_64
Active plugins: Python, Shell-api, Generic
Disabled plugins: Haskell, Perl, C/C++, fonts, PHP, Java, Ocaml, SugarActivity, R
Disabled flags: EXARCH, EPEL6, EPEL7, DISTTAG, BATCH

Comment 16 Robert-André Mauchin 🐧 2024-06-19 18:12:46 UTC
Thanks so much!

Comment 17 Fedora Admin user for bugzilla script actions 2024-06-19 18:15:08 UTC
The Pagure repository was created at https://src.fedoraproject.org/rpms/python-pyshacl

Comment 18 Fedora Update System 2024-06-19 18:51:35 UTC
FEDORA-2024-4e0ff5f922 (python-pyshacl-0.26.0-1.fc40) has been submitted as an update to Fedora 40.
https://bodhi.fedoraproject.org/updates/FEDORA-2024-4e0ff5f922

Comment 19 Fedora Update System 2024-06-20 02:14:52 UTC
FEDORA-2024-4e0ff5f922 has been pushed to the Fedora 40 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --refresh --advisory=FEDORA-2024-4e0ff5f922 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2024-4e0ff5f922

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 20 Fedora Update System 2024-06-28 01:58:04 UTC
FEDORA-2024-4e0ff5f922 (python-pyshacl-0.26.0-1.fc40) has been pushed to the Fedora 40 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.